"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// ../packages/core/index.ts
var core_exports = {};
__export(core_exports, {
  esbuildVueCSSVars: () => esbuildVueCSSVars,
  rollupVueCSSVars: () => rollupVueCSSVars,
  viteVueCSSVars: () => viteVueCSSVars,
  webpackVueCSSVars: () => webpackVueCSSVars
});
module.exports = __toCommonJS(core_exports);
var import_unplugin = require("unplugin");
var import_utils6 = require("../utils/index.cjs");
var import_pluginutils = require("@rollup/pluginutils");
var import_compiler_sfc = require("@vue/compiler-sfc");
var import_chalk = __toESM(require("chalk"), 1);

// ../packages/core/runtime/pre-process-css.ts
var import_path2 = require("path");
var import_fast_glob = __toESM(require("fast-glob"), 1);
var import_fs_extra = __toESM(require("fs-extra"), 1);
var import_utils3 = require("../utils/index.cjs");

// ../packages/core/parser/parser-variable.ts
var import_parser = require("@babel/parser");

// ../node_modules/.pnpm/estree-walker@3.0.3/node_modules/estree-walker/src/walker.js
var WalkerBase = class {
  constructor() {
    this.should_skip = false;
    this.should_remove = false;
    this.replacement = null;
    this.context = {
      skip: () => this.should_skip = true,
      remove: () => this.should_remove = true,
      replace: (node) => this.replacement = node
    };
  }
  replace(parent, prop, index, node) {
    if (parent && prop) {
      if (index != null) {
        parent[prop][index] = node;
      } else {
        parent[prop] = node;
      }
    }
  }
  remove(parent, prop, index) {
    if (parent && prop) {
      if (index !== null && index !== void 0) {
        parent[prop].splice(index, 1);
      } else {
        delete parent[prop];
      }
    }
  }
};

// ../node_modules/.pnpm/estree-walker@3.0.3/node_modules/estree-walker/src/sync.js
var SyncWalker = class extends WalkerBase {
  constructor(enter, leave) {
    super();
    this.should_skip = false;
    this.should_remove = false;
    this.replacement = null;
    this.context = {
      skip: () => this.should_skip = true,
      remove: () => this.should_remove = true,
      replace: (node) => this.replacement = node
    };
    this.enter = enter;
    this.leave = leave;
  }
  visit(node, parent, prop, index) {
    if (node) {
      if (this.enter) {
        const _should_skip = this.should_skip;
        const _should_remove = this.should_remove;
        const _replacement = this.replacement;
        this.should_skip = false;
        this.should_remove = false;
        this.replacement = null;
        this.enter.call(this.context, node, parent, prop, index);
        if (this.replacement) {
          node = this.replacement;
          this.replace(parent, prop, index, node);
        }
        if (this.should_remove) {
          this.remove(parent, prop, index);
        }
        const skipped = this.should_skip;
        const removed = this.should_remove;
        this.should_skip = _should_skip;
        this.should_remove = _should_remove;
        this.replacement = _replacement;
        if (skipped)
          return node;
        if (removed)
          return null;
      }
      let key;
      for (key in node) {
        const value = node[key];
        if (value && typeof value === "object") {
          if (Array.isArray(value)) {
            const nodes = value;
            for (let i = 0; i < nodes.length; i += 1) {
              const item = nodes[i];
              if (isNode(item)) {
                if (!this.visit(item, node, key, i)) {
                  i--;
                }
              }
            }
          } else if (isNode(value)) {
            this.visit(value, node, key, null);
          }
        }
      }
      if (this.leave) {
        const _replacement = this.replacement;
        const _should_remove = this.should_remove;
        this.replacement = null;
        this.should_remove = false;
        this.leave.call(this.context, node, parent, prop, index);
        if (this.replacement) {
          node = this.replacement;
          this.replace(parent, prop, index, node);
        }
        if (this.should_remove) {
          this.remove(parent, prop, index);
        }
        const removed = this.should_remove;
        this.replacement = _replacement;
        this.should_remove = _should_remove;
        if (removed)
          return null;
      }
    }
    return node;
  }
};
function isNode(value) {
  return value !== null && typeof value === "object" && "type" in value && typeof value.type === "string";
}

// ../node_modules/.pnpm/estree-walker@3.0.3/node_modules/estree-walker/src/index.js
function walk(ast, { enter, leave }) {
  const instance = new SyncWalker(enter, leave);
  return instance.visit(ast, null);
}

// ../packages/core/parser/parser-variable.ts
var import_utils = require("../utils/index.cjs");
var getVariable = (descriptor) => {
  let variableName = {};
  variableName = getVariableNameBySetup(setScriptContent(descriptor, "setup"));
  variableName = getVariableNameByScript(setScriptContent(descriptor, "script"), variableName);
  return variableName;
};
function setScriptContent(descriptor, type) {
  let content = "";
  if (descriptor.scriptSetup && type === "setup")
    content = descriptor.scriptSetup.content;
  if (descriptor.script && type === "script")
    content = descriptor.script.content;
  return content;
}
function getVariableNameBySetup(content, contextAst) {
  const variableNameBySetup = {};
  if (!content && !contextAst)
    return variableNameBySetup;
  const ast = contextAst || (0, import_parser.parse)(content, {
    sourceType: "module",
    plugins: ["typescript"]
  });
  walk(ast, {
    enter(node, parent) {
      if (parent && parent.type === "Program" && node.type === "VariableDeclaration") {
        const declarations = node.declarations;
        declarations.forEach((declare) => {
          const identifier = declare.id;
          variableNameBySetup[identifier.name] = declare.init;
        });
      }
    }
  });
  return variableNameBySetup;
}
function getVariableNameByScript(content, variableName) {
  if (!content)
    return variableName;
  let variableNameInScript = {};
  let isEmptyVariableNames = false;
  let setupIndex = 0;
  let dataIndex = 0;
  let hasSetup = false;
  let hasData = false;
  let setupReturnNode = {};
  let dataReturnNode = {};
  let index = 2;
  if ((0, import_utils.isEmptyObj)(variableName))
    isEmptyVariableNames = true;
  const ast = (0, import_parser.parse)(content, {
    sourceType: "module",
    plugins: ["typescript"]
  });
  walk(ast, {
    enter(node, parent) {
      if (parent && parent.type === "ObjectMethod" && node.type === "Identifier" && node.name === "setup") {
        hasSetup = true;
        setupIndex = index;
        index--;
      }
      if (parent && parent.type === "ObjectMethod" && node.type === "Identifier" && node.name === "data") {
        hasData = true;
        dataIndex = index;
        index--;
      }
      if (parent && parent.type === "ReturnStatement" && node.type === "ObjectExpression" && hasSetup) {
        hasSetup = false;
        setupReturnNode = node;
      }
      if (parent && parent.type === "ReturnStatement" && node.type === "ObjectExpression" && hasData) {
        hasData = false;
        dataReturnNode = node;
      }
    }
  });
  if (setupIndex === 0 && dataIndex === 0) {
    if (isEmptyVariableNames) {
      return variableName;
    } else {
      variableNameInScript = getVariableNameBySetup("", ast);
    }
    variableNameInScript = (0, import_utils.extend)(variableNameInScript, variableName);
    setupReturnNode = {};
    dataReturnNode = {};
    return variableNameInScript;
  }
  const setupReturnRes = getObjectExpressionReturnNode(setupReturnNode);
  const dataReturnRes = getObjectExpressionReturnNode(dataReturnNode);
  variableNameInScript = setupIndex > dataIndex ? (0, import_utils.extend)(setupReturnRes, dataReturnRes) : (0, import_utils.extend)(dataReturnRes, setupReturnRes);
  if (!isEmptyVariableNames)
    variableNameInScript = (0, import_utils.extend)(variableNameInScript, variableName);
  return variableNameInScript;
}
function getObjectExpressionReturnNode(node) {
  const res = {};
  if (!node.properties)
    return res;
  node.properties.forEach((value) => {
    const key = value.key;
    res[key.name] = value.value;
  });
  return res;
}
function matchVariable(importCSSModule, variableName) {
  const res = [];
  importCSSModule.forEach((val) => {
    const varNode = variableName[val];
    const resObj = {
      value: val,
      has: false,
      isRef: false
    };
    if (varNode) {
      resObj.has = true;
      if (varNode.type === "CallExpression" && varNode.callee.type === "Identifier" && varNode.callee.name === "ref")
        resObj.isRef = true;
    }
    res.push(resObj);
  });
  return res;
}

// ../packages/core/parser/parser-import.ts
var innerAtRule = "media,extend,at-root,debug,warn,forward,mixin,include,function,error,keyframes,font-face,page,supports,namespace,return,if,else,for,while,each,content,tailwind,apply,layer,screen,responsive,variants,config,applyRule";
function parseImports(content, helper) {
  const imports = [];
  let currentImport;
  let state = 0 /* Initial */;
  let i = 0;
  let AtPath = "";
  const source = content;
  while (i < source.length) {
    const char = source[i];
    if (/[\r\t\f\v\\]/g.test(char)) {
      i++;
      continue;
    }
    switch (state) {
      case 0 /* Initial */:
        if (char === "@")
          state = 3 /* AtStart */;
        if (char === "/" && source[i + 1] === "/")
          state = 1 /* InlineComment */;
        if (char === "/" && source[i + 1] === "*")
          state = 2 /* Comment */;
        break;
      case 1 /* InlineComment */:
        if (char === "\n")
          state = 0 /* Initial */;
        break;
      case 2 /* Comment */:
        if (char === "*" && source[i + 1] === "/")
          state = 0 /* Initial */;
        break;
      case 3 /* AtStart */:
        if (/[A-Za-z]$/.test(char))
          AtPath = AtPath + char;
        else
          state = 4 /* AtEnd */;
        if (i === source.length - 1) {
          if (char === '"' || char === "'")
            throw new Error("syntax error: unmatched quotes");
          else
            walkContentEnd(i);
        }
        if (!/[A-Za-z]$/.test(char) && char !== "\n" && char !== " " && char !== "-")
          throw new Error("syntax error");
        break;
      case 4 /* AtEnd */:
        if (char !== "\n" && char !== " " && char !== "-") {
          if (char === "/")
            throw new Error("syntax error");
          if (AtPath === "import") {
            AtPath = "";
            state = 5 /* AtImport */;
            currentImport = { type: "import", path: "" };
            i--;
          } else if (AtPath === "use") {
            AtPath = "";
            state = 6 /* AtUse */;
            currentImport = { type: "use", path: "" };
            i--;
          } else if (AtPath === "require") {
            AtPath = "";
            state = 7 /* AtRequire */;
            currentImport = { type: "require", path: "" };
            i--;
          } else {
            if (!innerAtRule.includes(AtPath))
              throw new Error("syntax error: unknown At Rule");
            AtPath = "";
            state = 0 /* Initial */;
          }
        }
        break;
      case 5 /* AtImport */:
      case 6 /* AtUse */:
      case 7 /* AtRequire */:
        if (char === "@" && !/[A-Za-z]$/.test(source[i - 1])) {
          i--;
          state = 0 /* Initial */;
          break;
        }
        if (char === "/" && (source[i + 1] === "/" || source[i + 1] === "*")) {
          i--;
          state = 0 /* Initial */;
          break;
        }
        if (char === "'" || char === '"') {
          currentImport.start = i;
          state = 8 /* QuotesStart */;
          break;
        }
        if (char !== "\n" && char !== " ") {
          currentImport.start = i;
          currentImport.path += char;
          state = 10 /* StringLiteral */;
          break;
        }
        break;
      case 8 /* QuotesStart */:
        if (char === "'" || char === '"') {
          currentImport.end = i;
          state = 9 /* QuotesEnd */;
          if (i === source.length - 1)
            walkContentEnd(i);
          break;
        }
        if (i === source.length - 1)
          throw new Error("syntax error: unmatched quotes");
        currentImport.path += char;
        break;
      case 9 /* QuotesEnd */:
        if (i === source.length - 1 || char === ";" || char === "\n") {
          walkContentEnd(i);
        } else {
          i--;
          state = 10 /* StringLiteral */;
        }
        break;
      case 10 /* StringLiteral */:
        if (char === ";" || char === "\n") {
          walkContentEnd(i);
          break;
        }
        if (char !== "@" && (char === " " || char === "," || char === '"' || char === "'")) {
          const curType = currentImport?.type;
          walkContentEnd(i);
          if (curType === "import") {
            state = 5 /* AtImport */;
            currentImport = { type: "import", path: "" };
          } else if (curType === "use") {
            state = 6 /* AtUse */;
            currentImport = { type: "use", path: "" };
          } else if (curType === "require") {
            state = 7 /* AtRequire */;
            currentImport = { type: "require", path: "" };
          }
          if (char === "'" || char === '"') {
            currentImport.start = i;
            state = 8 /* QuotesStart */;
            if (i === source.length - 1 && (char === '"' || char === "'"))
              throw new Error("syntax error: unmatched quotes");
            break;
          }
          break;
        }
        currentImport.path += char;
        if (i === source.length - 1)
          walkContentEnd(i);
        break;
    }
    i++;
  }
  function walkContentEnd(index) {
    pushCurrentImport(index);
    state = 0 /* Initial */;
  }
  function pushCurrentImport(index) {
    if (currentImport && currentImport.start !== void 0) {
      currentImport.end = index;
      if (helper) {
        helper.forEach((fn) => {
          currentImport = fn(currentImport);
        });
      }
      imports.push(currentImport);
      currentImport = void 0;
    }
  }
  function getCurState() {
    return state;
  }
  function getCurImport() {
    return currentImport;
  }
  return {
    imports,
    getCurState,
    getCurImport
  };
}

// ../packages/core/parser/parser-vbindm.ts
function parseVBindM(source) {
  const result = /* @__PURE__ */ new Set();
  let state = 0 /* Initial */;
  let i = 0;
  let curBuffer = "";
  let mark = 0;
  while (i < source.length) {
    const char = source[i];
    switch (state) {
      case 0 /* Initial */:
        if (char === "/" && source[i + 1] === "/")
          state = 1 /* InlineComment */;
        if (char === "/" && source[i + 1] === "*")
          state = 2 /* Comment */;
        if (char === "v")
          state = 3 /* VBindM */;
        if (char === ")")
          mark--;
        if (char === "(")
          mark++;
        break;
      case 1 /* InlineComment */:
        if (char === "\n")
          state = 0 /* Initial */;
        break;
      case 2 /* Comment */:
        if (char === "*" && source[i + 1] === "/")
          state = 0 /* Initial */;
        if (i === source.length - 1)
          throw new Error("syntax error: unmatched */");
        break;
      case 3 /* VBindM */:
        if (char === "-" && source[i + 1] === "b" && source[i + 2] === "i" && source[i + 3] === "n" && source[i + 4] === "d" && source[i + 5] === "-" && source[i + 6] === "m") {
          state = 4 /* VBindMValueStart */;
          i = i + 6;
        }
        break;
      case 4 /* VBindMValueStart */:
        if (char !== "(") {
          i--;
          state = 5 /* VBindMValue */;
          break;
        }
        mark++;
        break;
      case 5 /* VBindMValue */:
        if (char !== ")") {
          curBuffer = curBuffer + char;
        } else {
          i--;
          state = 6 /* VBindMValueEnd */;
        }
        break;
      case 6 /* VBindMValueEnd */:
        if (char === ")") {
          mark--;
          if (curBuffer) {
            result.add(curBuffer);
            curBuffer = "";
          }
          state = 0 /* Initial */;
        }
        break;
    }
    i++;
  }
  if (mark > 0)
    throw new Error("syntax error: unmatched )");
  if (mark < 0)
    throw new Error("syntax error: unmatched (");
  return [...result];
}

// ../packages/core/transform/transform-quotes.ts
function transformQuotes(importer2) {
  if (!importer2.path.startsWith('"') && !importer2.path.endsWith('"')) {
    if (importer2.path.startsWith("'") && importer2.path.endsWith("'"))
      importer2.path = `"${importer2.path.slice(1, -1)}"`;
    else
      importer2.path = `"${importer2.path}"`;
  }
  return importer2;
}

// ../packages/core/runtime/process-css.ts
var import_path = require("path");
var import_utils2 = require("../utils/index.cjs");
var getCSSFileRecursion = (lang = import_utils2.SUPPORT_FILE.CSS, key, cssFiles, cb, sfcPath, matchedMark = /* @__PURE__ */ new Set()) => {
  key = (0, import_utils2.completeSuffix)(key, lang);
  if (!cssFiles.get(key))
    key = (0, import_utils2.completeSuffix)(key, import_utils2.SUPPORT_FILE.CSS, true);
  if (matchedMark.has(key))
    return;
  const cssFile = cssFiles.get(key);
  if (cssFile) {
    if (!cssFile.sfcPath)
      cssFile.sfcPath = /* @__PURE__ */ new Set();
    cssFile.sfcPath?.add(sfcPath);
    matchedMark.add(key);
    cb(cssFile);
    if (cssFile.importer.size > 0) {
      cssFile.importer.forEach((value) => {
        getCSSFileRecursion(lang, value, cssFiles, cb, sfcPath, matchedMark);
      });
    }
  } else {
    throw new Error("path");
  }
};
var getVBindVariableListByPath = (descriptor, id, cssFiles, server, alias) => {
  const vbindVariable = /* @__PURE__ */ new Set();
  const injectCSSContent = /* @__PURE__ */ new Set();
  for (let i = 0; i < descriptor.styles.length; i++) {
    const content = descriptor.styles[i].content;
    const lang = descriptor.styles[i].lang === import_utils2.SUPPORT_FILE.STYLUS ? import_utils2.SUPPORT_FILE.STYL : descriptor.styles[i].lang;
    const idDirParse = (0, import_path.parse)(id);
    const parseImporterRes = parseImports(content);
    parseImporterRes.imports.forEach((res) => {
      const importerPath = handleAlias(res.path, alias, idDirParse.dir);
      try {
        getCSSFileRecursion(lang, importerPath, cssFiles, (res2) => {
          if (res2.vBindCode) {
            !server && injectCSSContent.add({ content: res2.content, lang: res2.lang, styleTagIndex: i });
            res2.vBindCode.forEach((vb) => {
              vbindVariable.add(vb);
            });
          }
        }, id);
      } catch (e) {
        if (e.message === "path") {
          const doc = "https://github.com/baiwusanyu-c/unplugin-vue-cssvars/pull/29";
          throw new Error(`Unable to resolve file under path '${res.path}', see: ${doc}`);
        } else {
          throw new Error(e.message);
        }
      }
    });
  }
  return {
    vbindVariableListByPath: (0, import_utils2.setTArray)(vbindVariable),
    injectCSSContent
  };
};
function handleAlias(path, alias, idDirPath) {
  let importerPath = "";
  if (!alias && !idDirPath)
    return path;
  if (alias) {
    for (const aliasKey in alias) {
      if (alias[aliasKey] && path.startsWith(aliasKey)) {
        importerPath = path.replace(aliasKey, alias[aliasKey]);
        break;
      }
    }
    if (importerPath)
      return (0, import_utils2.transformSymbol)(importerPath);
    importerPath = idDirPath ? (0, import_path.resolve)(idDirPath, path) : path;
  } else {
    idDirPath && (importerPath = (0, import_path.resolve)(idDirPath, path));
  }
  return (0, import_utils2.transformSymbol)(importerPath);
}

// ../packages/core/runtime/pre-process-css.ts
function preProcessCSS(options, alias, filesPath) {
  const { rootDir, includeCompile } = options;
  const files = filesPath || getAllCSSFilePath(includeCompile, rootDir);
  return createCSSFileModuleMap(files, rootDir, alias);
}
function getAllCSSFilePath(includeCompile, rootDir) {
  return import_fast_glob.default.sync(includeCompile, {
    ignore: import_utils3.FG_IGNORE_LIST,
    cwd: rootDir
  });
}
function createCSSFileModuleMap(files, rootDir, alias) {
  const cssFiles = /* @__PURE__ */ new Map();
  for (const file of files) {
    let absoluteFilePath = (0, import_path2.resolve)((0, import_path2.parse)(file).dir, (0, import_path2.parse)(file).base);
    absoluteFilePath = (0, import_utils3.transformSymbol)(absoluteFilePath);
    if (!cssFiles.get(absoluteFilePath)) {
      cssFiles.set(absoluteFilePath, {
        importer: /* @__PURE__ */ new Set(),
        vBindCode: [],
        content: "",
        lang: "css"
      });
    }
  }
  for (const file of files) {
    const fileDirParse = (0, import_path2.parse)(file);
    const fileSuffix = fileDirParse.ext;
    const code = import_fs_extra.default.readFileSync((0, import_utils3.transformSymbol)((0, import_path2.resolve)(rootDir, file)), { encoding: "utf-8" });
    const { imports } = parseImports(code, [transformQuotes]);
    const absoluteFilePath = (0, import_utils3.transformSymbol)((0, import_path2.resolve)(fileDirParse.dir, fileDirParse.base));
    const cssF = cssFiles.get(absoluteFilePath);
    imports.forEach((value) => {
      const importerPath = handleAlias(value.path.replace(/^"|"$/g, ""), alias, fileDirParse.dir);
      let importerVal = (0, import_utils3.completeSuffix)(importerPath, import_utils3.SUPPORT_FILE.CSS);
      if (fileSuffix !== `.${import_utils3.SUPPORT_FILE.CSS}`) {
        const importerValBySuffix = (0, import_utils3.completeSuffix)(
          importerPath,
          fileSuffix.split(".")[1],
          true
        );
        if (cssFiles.get(importerValBySuffix))
          importerVal = importerValBySuffix;
      }
      cssF.importer.add(importerVal);
    });
    cssF.vBindCode = parseVBindM(code);
    cssF.content = code;
    cssF.lang = fileSuffix.replaceAll(".", "");
    cssFiles.set(absoluteFilePath, cssF);
  }
  return cssFiles;
}

// ../packages/core/option/index.ts
var import_path3 = require("path");
var import_utils4 = require("../utils/index.cjs");
var defaultOption = {
  rootDir: (0, import_path3.resolve)(),
  include: import_utils4.DEFAULT_INCLUDE_REG,
  exclude: import_utils4.DEFAULT_EXCLUDE_REG,
  revoke: true,
  includeCompile: import_utils4.SUPPORT_FILE_LIST
};
function initOption(option) {
  option = (0, import_utils4.extend)(defaultOption, option);
  return option;
}

// ../packages/core/inject/inject-css.ts
var import_hash_sum = __toESM(require("hash-sum"), 1);

// ../packages/core/transform/transform-inject-css.ts
var import_magic_string = __toESM(require("magic-string"), 1);
function transformInjectCSS(code, importer2) {
  const mgc = new import_magic_string.default(code);
  importer2.forEach((imp) => {
    mgc.overwrite(imp.start, imp.end, "");
  });
  return mgc.toString().replaceAll("@import ;", "").replaceAll("v-bind-m", "v-bind");
}

// ../packages/core/inject/inject-css.ts
function injectCssOnServer(code, vbindVariableList, isHmring) {
  vbindVariableList && vbindVariableList.forEach((vbVar) => {
    if (!vbVar.hash && isHmring)
      vbVar.hash = (0, import_hash_sum.default)(vbVar.value + vbVar.has);
    code = code.replaceAll(`v-bind-m(${vbVar.value})`, `var(--${vbVar.hash})`);
  });
  return code;
}
function injectCssOnBuild(code, injectCSSContent, descriptor) {
  const cssContent = [...injectCSSContent];
  let resCode = "";
  descriptor.styles && descriptor.styles.forEach((value, index) => {
    let injectCssCode = "";
    cssContent.forEach((value2) => {
      if (value2.styleTagIndex === index)
        injectCssCode = `${injectCssCode}
${transformInjectCSS(value2.content, parseImports(value2.content).imports)}`;
    });
    const lang = value.lang || "css";
    const scoped = value.scoped ? "scoped" : "";
    resCode = `<style lang="${lang}" ${scoped}> ${injectCssCode}
${transformInjectCSS(value.content, parseImports(value.content).imports)} </style>`;
  });
  code = removeStyleTagsAndContent(code);
  return `${code}
 ${resCode}`;
}
function removeStyleTagsAndContent(html) {
  const newHtml = html.replace(/<style\b[^>]*>[\s\S]*?<\/style>/gi, "");
  return newHtml.replace(/<style\b[^>]*>/gi, "").replace(/<\/style>/gi, "");
}

// ../packages/core/inject/inject-cssvars.ts
var import_hash_sum2 = __toESM(require("hash-sum"), 1);
var importer = 'import { useCssVars as _useCssVars } from "vue"\n';
var injectCSSVars = (code, vbindVariableList, isScriptSetup) => {
  if (!vbindVariableList || vbindVariableList.length === 0)
    return { code, vbindVariableList };
  return injectCSSVarsOnServer(code, vbindVariableList, isScriptSetup);
};
function injectCSSVarsOnServer(code, vbindVariableList, isScriptSetup) {
  let resCode = "";
  const hasUseCssVars = code.includes("useCssVars");
  const useCssVars = createUseCssVarsCode(code, vbindVariableList, hasUseCssVars, isScriptSetup);
  if (isScriptSetup) {
    if (!hasUseCssVars) {
      resCode = code.replaceAll(
        "setup(__props, { expose }) {",
        `setup(__props, { expose }) {${useCssVars}`
      );
      resCode = `${importer}${resCode}`;
    } else {
      resCode = useCssVars;
    }
  } else {
    if (!hasUseCssVars) {
      resCode = code.replaceAll("const _sfc_main", "const __default__");
      resCode = resCode.replaceAll(
        "function _sfc_render",
        `${useCssVars}

        const __setup__ = __default__.setup
        __default__.setup = __setup__
          ? (props, ctx) => { __injectCSSVars__(); return __setup__(props, ctx) }
            : __injectCSSVars__
            const _sfc_main = __default__
            function _sfc_render`
      );
      resCode = `${importer}${resCode}`;
    } else {
      resCode = useCssVars;
    }
  }
  return { code: resCode, vbindVariableList };
}
function createUseCssVarsCode(code, vbindVariableList, isHas, isScriptSetup) {
  let cssvarsObjectCode = "";
  vbindVariableList.forEach((vbVar) => {
    const hashVal = vbVar.hash || (0, import_hash_sum2.default)(vbVar.value + vbVar.has);
    vbVar.hash = hashVal;
    let varStr = "";
    if (!isScriptSetup) {
      varStr = `_ctx.${vbVar.value}`;
    } else {
      varStr = vbVar.has ? vbVar.value : `_ctx.${vbVar.value}`;
      varStr = vbVar.isRef ? `${vbVar.value}.value` : varStr;
    }
    cssvarsObjectCode = `"${hashVal}": ${varStr},
  ${cssvarsObjectCode}`;
  });
  let resCode = "";
  if (isHas) {
    resCode = code.includes("_useCssVars((_ctx") ? code.replaceAll(
      "_useCssVars((_ctx) => ({",
      `_useCssVars((_ctx) => ({
  ${cssvarsObjectCode}`
    ) : code.replaceAll(
      "_useCssVars(_ctx => ({",
      `_useCssVars((_ctx) => ({
  ${cssvarsObjectCode}`
    );
  } else {
    resCode = `
     _useCssVars((_ctx) => ({
      ${cssvarsObjectCode}
    }));`;
    if (!isScriptSetup) {
      resCode = `
      const __injectCSSVars__ = () => {

        ${resCode}

      };`;
    }
  }
  return resCode;
}

// ../packages/core/hmr/hmr.ts
var import_utils5 = require("../utils/index.cjs");
function viteHMR(CSSFileModuleMap, userOptions, file, server) {
  const sfcModulesPathList = CSSFileModuleMap.get(file);
  triggerSFCUpdate(CSSFileModuleMap, userOptions, sfcModulesPathList, file, server);
}
function updatedCSSModules(CSSFileModuleMap, userOptions, file) {
  const updatedCSSMS = preProcessCSS(userOptions, userOptions.alias, [file]).get(file);
  CSSFileModuleMap.set(file, updatedCSSMS);
}
function triggerSFCUpdate(CSSFileModuleMap, userOptions, sfcModulesPathList, file, server) {
  if (sfcModulesPathList && sfcModulesPathList.sfcPath) {
    const ls = (0, import_utils5.setTArray)(sfcModulesPathList.sfcPath);
    ls.forEach((sfcp) => {
      const modules = server.moduleGraph.fileToModulesMap.get(sfcp) || /* @__PURE__ */ new Set();
      updatedCSSModules(CSSFileModuleMap, userOptions, file);
      const modulesList = (0, import_utils5.setTArray)(modules);
      for (let i = 0; i < modulesList.length; i++) {
        if (modulesList[i].id && modulesList[i].id.endsWith(".vue"))
          server.reloadModule(modulesList[i]);
      }
    });
  }
}

// ../packages/core/index.ts
var unplugin = (0, import_unplugin.createUnplugin)(
  (options = {}) => {
    const userOptions = initOption(options);
    const filter = (0, import_pluginutils.createFilter)(
      userOptions.include,
      userOptions.exclude
    );
    const CSSFileModuleMap = preProcessCSS(userOptions, userOptions.alias);
    const vbindVariableList = /* @__PURE__ */ new Map();
    let isScriptSetup = false;
    if (userOptions.server === void 0) {
      console.warn(import_chalk.default.yellowBright.bold(`[${import_utils6.NAME}] The server of option is not set, you need to specify whether you are using the development server or building the project`));
      console.warn(import_chalk.default.yellowBright.bold(`[${import_utils6.NAME}] See: https://github.com/baiwusanyu-c/unplugin-vue-cssvars/blob/master/README.md#option`));
    }
    let isServer = !!userOptions.server;
    let isHmring = false;
    return [
      {
        name: import_utils6.NAME,
        enforce: "pre",
        transformInclude(id) {
          return filter(id);
        },
        async transform(code, id) {
          try {
            if (id.endsWith(".vue")) {
              const { descriptor } = (0, import_compiler_sfc.parse)(code);
              isScriptSetup = !!descriptor.scriptSetup;
              const {
                vbindVariableListByPath,
                injectCSSContent
              } = getVBindVariableListByPath(descriptor, id, CSSFileModuleMap, isServer, userOptions.alias);
              const variableName = getVariable(descriptor);
              vbindVariableList.set(id, matchVariable(vbindVariableListByPath, variableName));
              if (!isServer)
                code = injectCssOnBuild(code, injectCSSContent, descriptor);
            }
            return code;
          } catch (err) {
            this.error(`[${import_utils6.NAME}] ${err}`);
          }
        },
        vite: {
          configResolved(config) {
            if (userOptions.server !== void 0)
              isServer = userOptions.server;
            else
              isServer = config.command === "serve";
          },
          handleHotUpdate(hmr) {
            if (import_utils6.SUPPORT_FILE_REG.test(hmr.file)) {
              isHmring = true;
              viteHMR(
                CSSFileModuleMap,
                userOptions,
                hmr.file,
                hmr.server
              );
            }
          }
        }
      },
      {
        name: `${import_utils6.NAME}:inject`,
        enforce: "post",
        async transform(code, id) {
          try {
            if (isServer) {
              if (id.endsWith(".vue")) {
                const injectRes = injectCSSVars(code, vbindVariableList.get(id), isScriptSetup);
                code = injectRes.code;
                injectRes.vbindVariableList && vbindVariableList.set(id, injectRes.vbindVariableList);
                isHmring = false;
              }
              if (id.includes("type=style"))
                code = injectCssOnServer(code, vbindVariableList.get(id.split("?vue")[0]), isHmring);
            }
            return code;
          } catch (err) {
            this.error(`[${import_utils6.NAME}] ${err}`);
          }
        }
      }
    ];
  }
);
var viteVueCSSVars = unplugin.vite;
var rollupVueCSSVars = unplugin.rollup;
var webpackVueCSSVars = unplugin.webpack;
var esbuildVueCSSVars = unplugin.esbuild;
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  esbuildVueCSSVars,
  rollupVueCSSVars,
  viteVueCSSVars,
  webpackVueCSSVars
});
